#version 440 core

uniform vec2 near_far; // near and far plane of the light cams
uniform vec4 lightPos; // light position

uniform mat4 M_mat; // model matrix from vertex shader
in vec4 FragPos; // vertex from geometry shader

void main(void) {
	// world space light position
	vec4 l_pos = M_mat * lightPos;

	// calculate distance
	//float WS_dist = distance(FragPos, l_pos);
	// map value to [0;1] by taking near/far plane into account
	//WS_dist = (WS_dist  near_far.x) / (near_far.y  near_far.x);

	float lightDistance = length(FragPos - l_pos);
    
    // map to [0;1] range by dividing by far_plane
    lightDistance = lightDistance / near_far.y;

	// write modified depth
	gl_FragDepth = lightDistance;
	// when using depth-only FBO, do NOT write to color!!!
}