#version 440 core

// INPUT: 1 triangle
layout(triangles) in;
// OUTPUT: 6 triangles (one for each face of the cubemap)
layout(triangle_strip, max_vertices=18) out;

uniform mat4 cm_mat[6]; // the lights view-projection matrices P * V[i]
out vec4 FragPos; // output vertex

void main(void) {
	// Iterate over the 6 cubemap faces
	// gl_Layer is a built-in variable to specify the face well render to
	for (gl_Layer = 0; gl_Layer < 6; ++gl_Layer) 
	{
		for (int tri_vert = 0; tri_vert < 3; ++tri_vert) // for each triangle's vertices
		{
			FragPos = gl_in[tri_vert].gl_Position;
			// transforming each world-space vertex to the relevant light space
			gl_Position = cm_mat[gl_Layer] * FragPos;
			EmitVertex();
		}
		EndPrimitive();
	}
}